@import "/src/assets/styles/grid-system.scss";

@mixin transition($transition...) {
    -webkit-transition: $transition;
    -moz-transition: $transition;
    -o-transition: $transition;
    -ms-transition: $transition;
    transition: $transition;
}

.app-bar {
    display: flex;
    flex-direction: row;
    align-content: center;
    align-items: center;
    position: sticky;
    width: 100%;
    height: 5.6rem;
    background-color: $primary-color;
    color: $on-primary-color;
}

.app-bar__menu-button {
    display: flex;
    align-items: center;
    justify-content: center;
    position: relative;
    margin-left: 0.8rem;
    width: 4.6rem;
    height: 4.6rem;
    border: none;
    color: $on-primary-color;
    background-color: rgba($primary-light-color, 0);
    cursor: pointer;
    span {
        display: flex;
    }
}

.app-bar__menu-button::before {
  position: absolute;
  z-index: -1;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
  background-color: rgba($primary-light-color, 0);
  content: "";
}

.app-bar__menu-button:hover::before {
  background-color: rgba($primary-light-color, 0.25);
  border-radius: 50%;
  @include transition(
      background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1),
      border-radius 0.2s cubic-bezier(0.4, 0, 0.6, 1)
  );
}

.app-bar__menu-button:active::before {
  background-color: rgba($on-primary-color, 0.5);
  @include transition(
    background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1)
  );
  animation: button-click;
  animation-duration: 0.2s;
}

// .app-bar__menu-button:hover {
//     border-radius: 50%;
//     background-color: rgba($primary-light-color, 0.25);
//     @include transition(
//         background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1),
//         border-radius 0.2s cubic-bezier(0.4, 0, 0.6, 1)
//     );
// }

.app-bar__title {
    display: flex;
    align-items: center;
    margin-left: 2.4rem;
    font-size: 1.8rem;
    white-space: nowrap;
    cursor: pointer;
}

.app-bar__title--centered {
    display: flex;
    flex-grow: 1;
    align-items: center;
    justify-content: center;
    margin-right: 5.4rem;
    font-size: 1.8rem;
    white-space: nowrap;
    cursor: pointer;
}

.app-bar__tool-bar {
    display: flex;
    flex-direction: row;
    align-self: stretch;
    align-items: stretch;
    margin: 0 2.4rem;

    .tool-bar__link {
        display: flex;
        align-items: center;
        padding: 0 1.2rem;
        color: $on-primary-color;
        font-size: 1.6rem;
        list-style-type: none;
        cursor: pointer;
        a {
            display: flex;
            color: $on-primary-color;
            text-decoration: none;
            white-space: nowrap;
        }
    }

    .tool-bar__link:hover {
        background-color: rgba($primary-light-color, 0.25);
        @include transition(
            background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1),
            border-radius 0.2s cubic-bezier(0.4, 0, 0.6, 1)
        );
    }

    .tool-bar__icon-button {
        display: flex;
        align-self: center;
        align-items: center;
        justify-content: center;
        position: relative;
        width: 4.6rem;
        height: 4.6rem;
        border: none;
        color: $on-primary-color;
        background-color: rgba($primary-light-color, 0);
        white-space: nowrap;
        cursor: pointer;
        span {
            display: flex;
        }
    }

    .tool-bar__icon-button::before {
        position: absolute;
        z-index: -1;
        top: 0;
        left: 0;
        bottom: 0;
        right: 0;
        background-color: rgba($primary-light-color, 0);
        content: "";
    }

    .tool-bar__icon-button:hover::before {
        background-color: rgba($primary-light-color, 0.25);
        border-radius: 50%;
        @include transition(
            background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1),
            border-radius 0.2s cubic-bezier(0.4, 0, 0.6, 1)
        );
    }

    .tool-bar__icon-button:active::before {
        background-color: rgba($on-primary-color, 0.5);
        @include transition(
          background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1)
        );
        animation: button-click;
        animation-duration: 0.2s;
    }

    .tool-bar__button {
        display: flex;
        position: relative;
        align-self: center;
        align-items: center;
        justify-content: center;
        padding: 0 1.2rem;
        height: 4.6rem;
        border: none;
        font-size: 1.6rem;
        list-style-type: none;
        color: $on-primary-color;
        background-color: rgba($primary-color, 0);
        white-space: nowrap;
        cursor: pointer;
        span {
            display: flex;
        }
    }

    .tool-bar__button::before {
        position: absolute;
        z-index: -1;
        top: 0;
        left: 0;
        bottom: 0;
        right: 0;
        border-radius: 0.4rem;
        background-color: rgba($primary-light-color, 0);
        content: "";
    }

    .tool-bar__button:hover::before {
        background-color: rgba($primary-light-color, 0.25);
        @include transition(
          background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1)
        )
      }

    .tool-bar__button:active::before {
        background-color: rgba($on-primary-color, 0.5);
        @include transition(
          background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1)
        );
        animation: button-click;
        animation-duration: 0.2s;
    }
}

.app-bar__spacer {
    flex-grow: 1;
}

@-webkit-keyframes button-click {
  from {
      transform: scale(0);
  }
  to {
      transform: scale(1);
  }
}

@-moz-keyframes button-click {
  from {
      transform: scale(0);
  }
  to {
      transform: scale(1);
  }
}

@keyframes button-click {
  from {
      transform: scale(0);
  }
  to {
      transform: scale(1);
  }
}
